<?php
/* Installation du script texte défilant, du fichier css associé et de vos images formant la bannière

Vous devez avoir au préalable préparé vos images, elles doivent avoir la même largeur et la même hauteur.
Pour la largeur vous pouvez choisir la largeur de votre site ( 750 , 960 ou 1170 px),
Si vous voulez que la bannière occupe toute la largeur de l'écran vos images devront avoir une définition suffisante (au moins 1500 px)
et après installation vous devrez régler manuellement le paramètre WidthImage dans head.inc.html (voir vidéo)

1 - Décompresser l'archive, vous obtenez un dossier bannieredefilante incluant un fichier install.php et un dossier images
2 - Placer vos images dans le dossier images (ne créez pas de sous-dossier) et supprimer les images par défaut
3 - Transférer le dossier bannieredefilante à la racine de votre site comme les dossiers core, module ou site
4 - Dans un navigateur saisissez l'adresse complète votre_site/bannieredefilante/install.php  

Ce fichier ajoute des lignes dans les fichiers head.inc.html et custom.css
Des copies des fichiers originaux sont réalisés.

Il copie vos images formant la bannière dans le dossier 'votre_site/site/file/source/bannieredefilante/'.

Les valeurs par défaut sont :
- largeur de la bannière : largeur de votre première image ( ordre alphabétique )
- durée du défilement total : 10s * nombre d'images

Le contenu est insensible aux mises à jour de Deltacms, votre bannière défilante sera pérenne après une mise à jour !
*/

// Vérification que les scripts ne sont pas déjà installés
$majhead = true;
$majcustom = true;
if(is_file('../site/data/head.inc.html')){
	$file = file_get_contents('../site/data/head.inc.html');
	if( strpos( $file, '<!-- ********** Bannière défilante **********-->') !== false){
		$majhead = false;
		echo 'Le script semble déjà installé dans head.inc.html, vous devez l\'effacer avant de procéder à une nouvelle installation :<br>Configurer le site, Avancée, Scripts, Script dans head <br>';
		echo 'Sélectionner puis effacer le texte entre  ********** Bannière défilante ********** et ********** Fin bannière défilante dans head.inc.html **********<br><br>';
	}
}
if(is_file('../site/data/custom.css')){
	$file = file_get_contents('../site/data/custom.css');
	if( strpos( $file, '/* ********** Bannière défilante ********** */' ) !== false){
		$majcustom = false;
		echo 'Le script semble déjà installé dans custom.css, vous devez l\'effacer avant de procéder à une nouvelle installation : <br> Personnaliser les thèmes puis Editeur CSS (fin du fichier)<br>';
		echo 'Sélectionner puis effacer le texte entre ********** Bannière défilante ********** et ********** Fin de la bannière défilante **********<br><br>';
	}
}


// Adresse complète du dossier contenant les images
$mydir = getcwd().'/images/';

//Recherche d'images dans le dossier pointé par $mydir	
if ($dir = @opendir($mydir)){
	while (($file = readdir($dir)) !== false)
	{
		if($file != ".." && $file != ".")
		{
			//trouver l'extension pour filtrer les images 
			$extension = pathinfo($file, PATHINFO_EXTENSION);
			$type=array('gif', 'GIF', 'jpg', 'JPG', 'jpeg', 'JPEG', 'tiff', 'TIFF', 'png', 'PNG');
			foreach($type as $value)
			{
				if ($extension==$value)
				{
					$filelist[] = $file; 
				}
			}
		}
	} 
	closedir($dir);
} 
$nbimages = sizeof($filelist);
$banniere = '';
$widthImage = '100%';

//Si il y a au moins une image et que les scripts ne sont pas installés on peut créer le script $banniere
if( $nbimages != 0 && $majhead === true && $majcustom === true){
	echo 'Vos images : <br>';
	//classement par ordre alphabétique
	sort($filelist); 
	if( ! is_dir('../site/file/source/bannieredefilante/')) mkdir('../site/file/source/bannieredefilante/');
	foreach ($filelist as $key => $val){
		$size = getimagesize($mydir.$val);
		echo $val .' '.$size[3].'<br/>';
		if( $key === 0) $widthImage = $size[0];
		copy( $mydir.$val , '../site/file/source/bannieredefilante/'.$val);
	}
	echo '<br>Vos images sont installées dans votre_site/site/file/source/bannieredefilante/<br><br>';
	//début du script
	$banniere = '<!-- ********** Bannière défilante **********-->
<!-- A placer dans head.inc.html-->
<!-- Bannière de Deltacms à régler sur position "Cachée", Menu de Deltacms à régler de préférence sur position "Dans le site" -->
<div align="center">
<div class="bannieredefilante" onmouseover="pause();" onmouseout="affiche();" >
<figure>
<!-- Images de la bannière défilante, la première sera utilisée sur les pages en bannière fixe -->';
// Première image
$banniere .='<a href="<?php echo helper::baseUrl().\'accueil\'; ?>">'.'<img src="<?php echo helper::baseUrl(false); ?>site/file/source/bannieredefilante/'.$filelist[0].'"></a>'."\r\n";  
// Images suivantes
for($i=1;$i<=$key;$i++)
	{
		$banniere .= '<a href="<?php echo helper::baseUrl().\'accueil\'; ?>">'.'<img src="<?php echo helper::baseUrl(false); ?>site/file/source/bannieredefilante/'.$filelist[$i].'"></a>'."\r\n";
	}
//fin du fichier
$banniere .= '</figure>
</div>
</div>
<script type="text/javascript">
var banniereFixe = false;

// ************* Paramètres à régler *************
var WidthImage = '.$widthImage.'; // Largeur des images en pixels ou \'100%\'
var spaceTop = 10; // nb de pixels au dessus de la bannière en grand écran
var spaceBottom = 10; // nb de pixels en dessous de la bannière en grand écran
var pagesBanniereFixe = [\'blog\', \'contact\']; // pages avec bannière fixe, en minuscule, sans accent, espace remplacé par tiret -, mettre une virgule suivi d\'un espace entre chaque page
// ************* Fin des paramètres à régler dans ce fichier, autres réglages à effectuer dans custom.css *************

// Dimensionnement de la bannière en fonction du client et des images
$.slider = function(){
  // Pages avec bannière fixe, les autres seront en bannière défilante
  var page = \'<?php echo $this->getUrl(0); ?>\'; 
  pagesBanniereFixe.forEach(function(currentValue) {
  if( page == currentValue) banniereFixe = true ;
  });
  // Mise en forme de la bannière et adaptation de la largeur de la bannière à l\'écran du client
  var themeBorderRadius = "<?php echo $this->getData([\'theme\', \'site\', \'radius\']); ?>";
  var themeBoxShadow = "<?php echo $this->getData([\'theme\', \'site\', \'shadow\']); ?>";
  $(".bannieredefilante").css(\'font-size\', 0);
  $(".bannieredefilante").css(\'position\', \'relative\'); 
  $(".bannieredefilante").css(\'border-radius\', themeBorderRadius);   
  $(".bannieredefilante").css(\'box-shadow\', themeBoxShadow); 
  $(".bannieredefilante").css(\'z-index\', 1);
  if(document.body.clientWidth < WidthImage ){
	  $(".bannieredefilante").css(\'width\', document.body.clientWidth );
	  spaceTop = 0;   
	  spaceBottom = 0;
  }
  else{
	  $(".bannieredefilante").css(\'width\', WidthImage);
  }
  $("body").css(\'margin-top\', spaceTop); 
  $(".bannieredefilante").css(\'margin-bottom\', spaceBottom); 
  if( banniereFixe == false){
	$(".bannieredefilante figure").css(\'animation-play-state\', \'running\');
  }
  else{
	$(".bannieredefilante figure").css(\'animation-play-state\', \'paused\'); 
  }
};

$(document).ready(function() {
  $.slider();
});

$(window).resize(function(){
	$.slider();
});

function affiche(){
	$.slider();
}

function pause(){
	$(".bannieredefilante figure").css(\'animation-play-state\', \'paused\');
}
</script>
<!-- ********** Fin bannière défilante dans head.inc.html **********-->';
	
	// Ajoute le script $banniere au fichier head.inc.html
	$head = '';
	$headexist = false;
	if( is_file( '../site/data/head.inc.html')){
		$headexist = true;
		copy('../site/data/head.inc.html', '../site/data/copy_head.inc.html');
		$head = file_get_contents('../site/data/head.inc.html');
	}
	$head .= "\r\n".$banniere;
	file_put_contents( '../site/data/head.inc.html', $head);
	echo 'Script installé dans head.inc.html<br>';
	if( $headexist ) echo ' Une copie du fichier original est disponible : site/data/copy_head.inc.html<br><br>';


	// Création du script à ajouter à custom.css
	$customcss = '/* ********** Bannière défilante ********** */

	/* Les valeurs à régler ont un commentaire, les 3 premiers sont obligatoires si votre bannière ne comporte pas 4 images */

	@keyframes slidy {
		0% { margin-left: 0%; }
		100% { margin-left: '.-100*($nbimages-1).'%; } /* -100% x (nombre d\'images - 1) soit -300% pour 4 images */
	}

	.bannieredefilante {
	  border:0px solid;
	  overflow: hidden;
	  font-size: 0px;
	}

	.bannieredefilante figure img {
		width: '.(100/$nbimages).'%; /* 100% / nombre d\'images soit 25% pour 4 images*/
		float: left; 
	}

	.bannieredefilante figure { 	
		display:block;
		position: relative;
		width: '.(100*$nbimages).'%; /* 100% x nombre d\'images soit 400% pour 4 images*/
		animation-name: slidy;
		animation-duration : '.(10*$nbimages).'s; /* durée d\'un défilement */
		animation-iteration-count : infinite; /* nombre de défilements ou infinite */
		animation-timing-function: linear; /* déroulement de l\'animation à chaque cycle */
		animation-direction: normal; /* direction de l\'animation normal, reverse ou alternate */
	}

	/* ********** Fin de la bannière défilante ********** */';

	$css= '';
	if( is_file( '../site/data/custom.css')){
		copy('../site/data/custom.css', '../site/data/copy_custom.css');
		$css = file_get_contents('../site/data/custom.css');
	}
	$css .= "\r\n".$customcss;
	file_put_contents( '../site/data/custom.css', $css);
	echo 'Css installé dans custom.css<br>';
	echo 'Une copie du fichier original est disponible : site/data/copy_custom.css<br><br>';

}
?>